package com.jiuqi.syntax;

package .tmp;

import com.jiuqi.syntax.CommonData;
import com.jiuqi.syntax.CommonDatas;
import com.jiuqi.syntax.CustomFunctionListener;
import com.jiuqi.syntax.Function;
import com.jiuqi.util.ChineseCurrencyFormat;
import com.jiuqi.util.ChineseNumberFormat;
import com.jiuqi.util.IDCard;
import com.jiuqi.util.StringTokenEnumeration;
import java.text.NumberFormat;
import java.util.Enumeration;

public final class CommonFunctionListener extends CustomFunctionListener {
  public CommonFunctionListener() {
    Function func = this.functions.addFunc("ABS", "绝对值", "返回给定数值的绝对值", 2);
    func.params.addParam("value", "数值", 2);
    func = this.functions.addFunc("INT", "取整", "将数值向下取整为最接近的整数", 2);
    func.params.addParam("value", "数值", 2);
    func = this.functions.addFunc("ROUND", "四舍五入取整", "按指定的位数对数值进行四舍五入", 2);
    func.params.addParam("value", "数值", 2);
    func.params.addParam("dec", "数位", 2, true);
    func = this.functions.addFunc("MOD", "求模", "返回两数相除的余数", 2);
    func.params.addParam("value", "数值", 2);
    func.params.addParam("mvalue", "模数", 2);
    func = this.functions.addFunc("POWER", "求幂", "返回某数的乘幂", 2);
    func.params.addParam("value", "数值", 2);
    func.params.addParam("exponent", "幂数", 2);
    func = this.functions.addFunc("TAN", "正切值", "返回给定数值的正切值", 2);
    func.params.addParam("value", "数值", 2);
    func = this.functions.addFunc("ATAN", "反正切值", "返回给定数值的反正切值", 2);
    func.params.addParam("value", "数值", 2);
    func = this.functions.addFunc("LN", "自然对数", "返回给定数值的自然对数", 2);
    func.params.addParam("value", "数值", 2);
    func = this.functions.addFunc("LOG10", "10为底的对数", "返回给定数值的10为底的对数", 2);
    func.params.addParam("value", "数值", 2);
    func = this.functions.addFunc("LOG", "对数", "返回给定数值的对数", 2);
    func.params.addParam("value", "数值", 2);
    func = this.functions.addFunc("L$", "左串", "从一个文本字符串的第一个字符开始返回指定个数的字符", 3);
    func.params.addParam("text", "字符值", 3);
    func.params.addParam("length", "长度", 1);
    func = this.functions.addFunc("M$", "中串", "从文本字符串中指定的起始位置起返回指定长度的字符", 3);
    func.params.addParam("text", "字符值", 3);
    func.params.addParam("start", "开始位置", 1);
    func.params.addParam("length", "长度", 1);
    func = this.functions.addFunc("R$", "右串", "从一个文本字符串的最后一个字符开始返回指定个数的字符", 3);
    func.params.addParam("text", "字符值", 3);
    func.params.addParam("length", "长度", 1);
    func = this.functions.addFunc("LEN", "长度", "返回文本字符串中的字符个数", 1);
    func.params.addParam("text", "字符值", 3);
    func = this.functions.addFunc("VAL", "求值", "将一个文本字符串转换成数值", 2);
    func.params.addParam("text", "字符值", 3);
    func = this.functions.addFunc("POS", "在字符串中", "返回一个字符串在另一个字符串中出现的起始位置", 1);
    func.params.addParam("substring", "子字符串", 3);
    func.params.addParam("totalstring", "完整字符值", 3);
    func = this.functions.addFunc("ISDIGIT", "是数字", "判断一个字符串是否仅包含数字", 5);
    func.params.addParam("text", "字符值", 3);
    func = this.functions.addFunc("STR", "字符", "将数值转换成文本", 3);
    func.params.addParam("value", "数值", 2);
    func.params.addParam("dec", "小数位", 1, true);
    func.params.addParam("thousand", "千分位", 5, true);
    func = this.functions.addFunc("UPPERCASE", "字符转大写", "将给定字符值中的所有小写字母转为大写字母", 3);
    func.params.addParam("value", "字符值", 3);
    func = this.functions.addFunc("LOWERCASE", "字符转小写", "将给定字符值中的所有大写字母转为小写字母", 3);
    func.params.addParam("value", "字符值", 3);
    func = this.functions.addFunc("MONEYSTR", "中文金额", "将金额转换成金额中文文本", 3);
    func.params.addParam("money", "金额数值", 2);
    func.params.addParam("prefix", "输出前缀", 3, true);
    func.params.addParam("suffix", "输出后缀", 3, true);
    func = this.functions.addFunc("DATEVALUE", "日期转换", "将日期值从字符串转化成日期类型", 6);
    func.params.addParam("text", "字符值", 3);
    func.params.addParam("format", "日期格式", 3, true);
    func = this.functions.addFunc("FORMATDATE", "格式化日期", "将日期值按照格式转成字符串", 3);
    func.params.addParam("date", "日期值", 6);
    func.params.addParam("format", "日期格式", 3, true);
    func = this.functions.addFunc("DATE", "日期", "将指定的年、月、日转化成日期类型", 6);
    func.params.addParam("year", "年", 1);
    func.params.addParam("month", "月", 1);
    func.params.addParam("day", "日", 1);
    func = this.functions.addFunc("DATEADD", "加日期", "返回调整后的新日期", 6);
    func.params.addParam("date", "日期", 6);
    func.params.addParam("year", "年", 1);
    func.params.addParam("month", "月", 1, true);
    func.params.addParam("day", "日", 1, true);
    func = this.functions.addFunc("YEAR", "取年", "返回日期中的年份", 1);
    func.params.addParam("date", "日期", 6);
    func = this.functions.addFunc("MONTH", "取月", "返回日期中的月份", 1);
    func.params.addParam("date", "日期", 6);
    func = this.functions.addFunc("DAY", "取日", "返回日期中的日子", 1);
    func.params.addParam("date", "日期", 6);
    func = this.functions.addFunc("TODAY", "今天", "返回当前日期", 6);
    func = this.functions.addFunc("ISIDCARD", "是合法身份证", "判断个人身份证是否合法", 5);
    func.params.addParam("text", "身份证", 3);
    func = this.functions.addFunc("IDCARD18", "转换成18位身份证", "将15位身份证转换成18位身份证", 3);
    func.params.addParam("text", "身份证", 3);
    func = this.functions.addFunc("IDCARDDATE", "取身份证日期", "根据个人身份证返回个人的出生日期", 6);
    func.params.addParam("text", "身份证", 3);
    func = this.functions.addFunc("IDC", "校验位", "返回单位法人代码的校验位", 3);
    func.params.addParam("text", "单位法人代码前8位", 3);
    func = this.functions.addFunc("ISNULL", "是空值", "判断数据是否是空值", 5);
    func.params.addParam("data", "数据", 0);
    func = this.functions.addFunc("EXISTCHINESE", "有中文", "判断文本字符串中是否存在中文", 5);
    func.params.addParam("text", "字符串", 3);
    func = this.functions.addFunc("INLIST", "在列表中", "判断文本字符串中是否存在列表中", 5);
    func.params.addParam("text", "字符串", 3);
    func.params.addParam("comparetext", "比较字符串或字典标识", 3);
    func.isInfiniteParam = true;
    func = this.functions.addFunc("DICTVALUE", "取字典值", "依据编码从字典中取得含义值", 3);
    func.params.addParam("code", "编码", 3);
    func.params.addParam("dict", "字典标识", 3, false, true);
    func.params.addParam("mean", "含义列", 3, true, true);
    func = this.functions.addFunc("GETMEANING", "取字典值", "依据编码从字典中取得含义值", 3);
    func.params.addParam("code", "编码", 3);
    func.params.addParam("dict", "字典标识", 3, false, true);
    func.params.addParam("mean", "含义列", 3, true, true);
    func = this.functions.addFunc("STATE", "单位状态", "返回单位状态", 1);
    func.params.addParam("solution", "业务方案标识", 3, true);
    func.params.addParam("report", "报表标识", 3, true);
    func = this.functions.addFunc("FLOATSTAT", "浮动行统计", "返回浮动行统计值", 2);
    func.params.addParam("expression", "浮动行取值表达式", 3);
    func.params.addParam("condition", "浮动行条件", 3, true);
    func.params.addParam("statmode", "统计模式", 3, true, true);
    func = this.functions.addFunc("FLOATCOPY", "浮动行Copy", "执行浮动行Copy功能", 1);
    func.params.addParam("sourceRelaExp", "源浮动行关联表达式", 3);
    func.params.addParam("destRelaExp", "目标浮动行关联表达式", 3);
    func.params.addParam("sourceFilter", "源浮动行过滤条件", 3);
    func.params.addParam("calcExps", "浮动行间赋值表达式", 3);
    func.params.addParam("isClearData", "是否清除目标浮动行数据", 5, true);
    func.params.addParam("isSumCopy", "是否将浮动编码一样浮动行合计复制", 5, true);
    func = this.functions.addFunc("NULLBLOB", "空二进制", "返回空二进制值", 8);
    func = this.functions.addFunc("SUM", "汇总统计", "返回汇总值", 2);
    func.params.addParam("expression", "取值表达式", 3);
    func = this.functions.addFunc("MAX", "最大值统计", "返回最大值", 2);
    func.params.addParam("expression", "取值表达式", 3);
    func = this.functions.addFunc("MIN", "最小值统计", "返回最小值", 2);
    func.params.addParam("expression", "取值表达式", 3);
    func = this.functions.addFunc("AVG", "平均值统计", "返回平均值", 2);
    func.params.addParam("expression", "取值表达式", 3);
    func = this.functions.addFunc("COUNT", "计数值统计", "返回计数值", 2);
    func.params.addParam("expression", "数值表达式", 3);
    func = this.functions.addFunc("CHINESESTR", "中文数值", "将数值转换成中文文本", 3);
    func.params.addParam("value", "数值", 1);
    func.params.addParam("capital", "是否大写", 5, true);
    func = this.functions.addFunc("TokenOf", "提取文本单词", "返回单词内容", 3);
    func.params.addParam("text", "文本内容", 3);
    func.params.addParam("index", "单词索引", 1);
    func.params.addParam("delim", "单词分隔符", 3, true);
    func = this.functions.addFunc("ChineseDigitUnit", "计算中文数值单位", "返回数值表示的中文单位值", 3);
    func.params.addParam("unitvalue", "单位数值", 2);
    func = this.functions.addFunc("MakeLink", "生成超级链接", "生成超级链接存储编码字符串", 3);
    func.params.addParam("url", "链接地址", 3);
    func.params.addParam("text", "显示文本", 3, true);
    func.params.addParam("target", "目标窗口", 3, true);
    func = this.functions.addFunc("Trim", "去除字符串头尾空格", "去除字符串头尾的空格", 3);
    func.params.addParam("text", "字符串值", 3);
    func = this.functions.addFunc("FormatNum", "格式化数值", "将数值格式化为字符串", 3);
    func.params.addParam("value", "数值", 2);
    func.params.addParam("decimal", "小数位", 1, true);
    func.params.addParam("thousand", "是否需要千分位", 5, true);
    func.params.addParam("minIntLen", "最小整数位数，不足时左侧补0，默认不限制", 1, true);
  }
  
  public int callFunction(String funcName, CommonDatas paramValues, CommonData resultData, boolean isCheckMode) {
    if (funcName.equalsIgnoreCase("ISIDCARD")) {
      if (paramValues.size() != 1)
        return 202; 
      resultData.type = 5;
      String str = (paramValues.getItem(0)).cdString;
      resultData.isNull = (str == null);
      resultData.cdBool = IDCard.isIDCard(str);
      return 0;
    } 
    if (funcName.equalsIgnoreCase("IDCARD18")) {
      if (paramValues.size() != 1)
        return 202; 
      resultData.type = 3;
      String str = (paramValues.getItem(0)).cdString;
      resultData.isNull = (str == null);
      resultData.cdString = IDCard.IDCard18(str);
      return 0;
    } 
    if (funcName.equalsIgnoreCase("IDCARDDATE")) {
      if (paramValues.size() != 1)
        return 202; 
      resultData.type = 6;
      String str = (paramValues.getItem(0)).cdString;
      resultData.cdDate = IDCard.getIDCardDate(str);
      resultData.isNull = (resultData.cdDate == null);
      return 0;
    } 
    if (funcName.equalsIgnoreCase("UPPERCASE")) {
      if (paramValues.size() != 1)
        return 202; 
      resultData.type = 3;
      String str = (paramValues.getItem(0)).cdString;
      resultData.isNull = (str == null);
      resultData.cdString = (str == null) ? null : str.toUpperCase();
      return 0;
    } 
    if (funcName.equalsIgnoreCase("LOWERCASE")) {
      if (paramValues.size() != 1)
        return 202; 
      resultData.type = 3;
      String str = (paramValues.getItem(0)).cdString;
      resultData.isNull = (str == null);
      resultData.cdString = (str == null) ? null : str.toLowerCase();
      return 0;
    } 
    if (funcName.equalsIgnoreCase("MONEYSTR")) {
      if (paramValues.size() != 3)
        return 202; 
      resultData.type = 3;
      resultData.isNull = false;
      ChineseCurrencyFormat f = new ChineseCurrencyFormat((paramValues.getItem(1)).cdString, (paramValues.getItem(2)).cdString);
      resultData.cdString = f.format(paramValues.getItem(0).getIntRealValue());
      return 0;
    } 
    if (funcName.equalsIgnoreCase("CHINESESTR")) {
      if (paramValues.size() != 2)
        return 202; 
      resultData.type = 3;
      resultData.isNull = false;
      ChineseNumberFormat f = new ChineseNumberFormat((paramValues.getItem(1)).isNull ? false : (paramValues.getItem(1)).cdBool);
      resultData.cdString = f.format((long)paramValues.getItem(0).getIntRealValue());
      return 0;
    } 
    if (funcName.equalsIgnoreCase("TokenOf")) {
      StringTokenEnumeration stringTokenEnumeration;
      if (paramValues.size() != 3)
        return 202; 
      resultData.type = 3;
      resultData.isNull = true;
      Enumeration tokens = null;
      String delim = (paramValues.getItem(2)).cdString;
      if (delim == null || delim.length() == 0) {
        stringTokenEnumeration = new StringTokenEnumeration((paramValues.getItem(0)).cdString);
      } else {
        stringTokenEnumeration = new StringTokenEnumeration((paramValues.getItem(0)).cdString, delim);
      } 
      int count = 0;
      int index = (int)paramValues.getItem(1).getIntRealValue();
      while (stringTokenEnumeration.hasMoreElements()) {
        Object ret = stringTokenEnumeration.nextElement();
        if (count == index) {
          resultData.isNull = false;
          resultData.cdString = (String)ret;
          break;
        } 
        count++;
      } 
      return 0;
    } 
    if (funcName.equalsIgnoreCase("ChineseDigitUnit")) {
      if (paramValues.size() != 1)
        return 202; 
      resultData.type = 3;
      String unitExpr = (paramValues.getItem(0)).isNull ? null : ChineseNumberFormat.toChineseDigitUnit(paramValues.getItem(0).getIntRealValue());
      if (unitExpr == null) {
        resultData.isNull = true;
      } else {
        resultData.isNull = false;
        resultData.cdString = unitExpr;
      } 
      return 0;
    } 
    if (funcName.equalsIgnoreCase("Trim")) {
      if (paramValues.size() != 1)
        return 202; 
      resultData.type = 3;
      String text = (paramValues.getItem(0)).isNull ? null : (paramValues.getItem(0)).cdString;
      if (text == null) {
        resultData.isNull = true;
      } else {
        resultData.isNull = false;
        resultData.cdString = text.trim();
      } 
      return 0;
    } 
    if (funcName.equalsIgnoreCase("FormatNum")) {
      if (paramValues.size() != 4)
        return 202; 
      resultData.type = 3;
      if ((paramValues.getItem(0)).isNull) {
        resultData.isNull = true;
      } else {
        NumberFormat numFmt = NumberFormat.getInstance();
        if (!(paramValues.getItem(1)).isNull) {
          int decSize = (int)paramValues.getItem(1).getIntRealValue();
          if (decSize >= 0) {
            numFmt.setMaximumFractionDigits(decSize);
            numFmt.setMinimumFractionDigits(decSize);
          } 
        } 
        numFmt.setGroupingUsed((paramValues.getItem(2)).isNull ? true : (paramValues.getItem(2)).cdBool);
        if (!(paramValues.getItem(3)).isNull) {
          int intSize = (int)paramValues.getItem(3).getIntRealValue();
          if (intSize > 0)
            numFmt.setMinimumIntegerDigits(intSize); 
        } 
        resultData.cdString = numFmt.format(paramValues.getItem(0).getIntRealValue());
        resultData.isNull = false;
      } 
      return 0;
    } 
    return 201;
  }
}
